--[[
-- ORPHANED ORPHANED ORPHANED
--
-- No developer cares about this addon.
--
-- Noone will fix problems you find with this code, noone will implement new
-- features, noone will update it for patches.
--
-- Noone will code it so that it enables when a boss is engaged instead of when
-- the bossmod is enabled, for several reasons. If you can not figure out these
-- reasons yourself, then don't bother asking, because you're not worth
-- the time it takes to answer.
--
-- ORPHANED ORPHANED ORPHANED
--]]

----------------------------
--      Localization      --
----------------------------
local L = AceLibrary("AceLocale-2.2"):new("BigWigsKLHTMTarget")

L:RegisterTranslations("enUS", function() return {
	["KLHTM Target"] = true,
	["klhtmt"] = true,
	["Options for the setting KLH master target."] = true,
	["Set the KLH Threatmeter master target when a BigWigs boss module is enabled."] = true,
	["Set master target"] = true,
	["target"] = true,
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

BigWigsKLHTMTarget = BigWigs:NewModule(L["KLHTM Target"])
BigWigsKLHTMTarget.revision = tonumber(string.sub("$Revision: 25921 $", 12, -3))
BigWigsKLHTMTarget.defaults = {
	enabled = true,
}
BigWigsKLHTMTarget.external = true
BigWigsKLHTMTarget.consoleCmd = L["klhtmt"]
BigWigsKLHTMTarget.consoleOptions = {
	type = "group",
	name = L["KLHTM Target"],
	desc = L["Options for the setting KLH master target."],
	args = {
		[L["target"]] = {
			type = "toggle",
			name = L["Set master target"],
			desc = L["Set the KLH Threatmeter master target when a BigWigs boss module is enabled."],
			get = function() return BigWigsKLHTMTarget.db.profile.enabled end,
			set = function(v) BigWigsKLHTMTarget.db.profile.enabled = v end,
		},
	}
}

------------------------------
--      Initialization      --
------------------------------

function BigWigsKLHTMTarget:OnEnable()
	self.bosses = {}

	if loadstring("return function(...) return ... end") then
		--self.core:Print("Since TargetByName is no longer usable in 2.0, BigWigs_KLHTMTarget will not work any more. Sorry :(")
	end
	self.core:Print("Since TargetByName is no longer usable in 2.0, a partial replacement has been used to get it back. BigWigs_KLHTMTarget may work less good.")
	self:RegisterEvent("BigWigs_RecvSync")
	self:TriggerEvent("BigWigs_ThrottleSync", "KLHTMSetMA", 10)
end

------------------------------
--      Targeting           --
------------------------------

BigWigsKLHTMTarget.unitIds = {
};

function BigWigsKLHTMTarget:InsertIds(t, number, formatStr)
	for i=1,number do
		tinsert(t, format(formatStr, i));
	end
end

local unitPrefixes = {
	["party%dtarget"] = 5;
	["raid%dtarget"] = 40;
};
for k, v in pairs(unitPrefixes) do
	BigWigsKLHTMTarget:InsertIds(BigWigsKLHTMTarget.unitIds, v, k);
end

function BigWigsKLHTMTarget:DoTarget(name)
	--TargetByName(unit, true)
	local unit = self:GetNameAsUnit(name);
	if ( unit ) then 
		TargetUnit(unit);
		return true;
	else
		return false;
	end
end

function BigWigsKLHTMTarget:GetNameAsUnit(name)
	for k, v in self.unitIds do
		if ( UnitExists(v) ) and ( UnitName(v) == name ) then
			return v;
		end
	end
	return nil;
end

function BigWigsKLHTMTarget:IsEngagedWithName(name)
	if ( not UnitAffectingCombat("player") ) then
		return false;
	end
	local target = UnitName("target");
	if ( type(target) == "string" ) and ( target == name ) and ( UnitAffectingCombat("target") ) then
		return true;
	end
	local unit = self:GetNameAsUnit(name);
	if ( unit ) and ( UnitAffectingCombat(unit) ) then
		return true;
	else
		return false;
	end
end

------------------------------
--      Event Handlers      --
------------------------------

function BigWigsKLHTMTarget:BigWigs_RecvSync(sync, rest)
	if not rest or not self.db.profile.enabled then return end
	if not IsRaidOfficer() and not IsRaidLeader() and UnitInRaid("player") then return end

	if sync == "EnableModule" then
		if not self.core:HasModule(rest) then return end
		local m = self.core:GetModule(rest)
		if not m.zonename == GetRealZoneText() then return end
		if m and m:IsBossModule() and not self.bosses[m:ToString()] then
			self.bosses[m:ToString()] = true
			local enableTriggers = type(m.enabletrigger) == "string" and {m.enabletrigger} or m.enabletrigger
			local target = UnitName("target")
			for k, unit in pairs(enableTriggers) do
				self:DoTarget(unit);
				if UnitName("target") == unit then
					self:TriggerEvent("BigWigs_SendSync", "KLHTMSetMA "..unit)
					break
				end
			end
			if target then self:DoTarget(target); end
		end
	elseif sync == "KLHTMSetMA" then
		local target = UnitName("target")
		self:DoTarget(target);
		if UnitExists("target") and UnitName("target") == rest then
			klhtm.net.sendmastertarget()
		end
		if target then self:DoTarget(target); end
	end
end

